import random

#
# class Spells(object):
#     def __init__(self, combat_encounter):
#         self.player = combat_encounter.player  # has to feed into player
#         self.mob = combat_encounter.mob  # has to feed into player
#         self.player_defended_recently = combat_encounter.player_defended_recently  # has to feed into combat_encounter
#         self.player_defence_cost = combat_encounter.player_defence_cost  # has to feed into combat_encounter
#         self.mob_defended_recently = combat_encounter.mob_defended_recently  # has to feed into combat_encounter
#         self.turn_counter = combat_encounter.turn_counter  # has to feed into combat_encounter
#         self.fireball_burn_counter = combat_encounter.fireball_burn_counter  # has to feed into combat_encounter
#         self.spell_book = combat_encounter.PC.spell_book  # has to feed into player
#         self.player_select = 0
#
#     def fireball(self):
#         if self.player_select == "1":
#             if self.player.ability_power >= 5:
#                 calc_damage = 5 + self.player.level + random.choice(range(0, self.player.wisdom + 1))
#                 print(self.player.player_name + " casts Fireball, dealing " + str(calc_damage) + " damage.")
#                 self.player.ability_power -= 5
#                 self.player.turn -= 2
#                 self.mob.current_health -= calc_damage
#                 self.fireball_burn_counter = 3
#                 self.player_defence_cost = 1
#                 self.player_defended_recently = False
#             else:
#                 print("Not enough AP for that")
#
#     def heal(self):
#         if self.player_select == "2":
#             if self.player.ability_power >= 3:
#                 calc_heal = 3 + self.player.level + random.choice(range(0, self.player.wisdom + 1))
#                 print(self.player.player_name + " casts Heal, healing " + str(calc_heal) + " HP.")
#                 self.player.ability_power -= 3
#                 self.player.turn -= 1
#                 self.player.current_health += calc_heal
#                 self.player_defence_cost = 1
#                 self.player_defended_recently = False
#             else:
#                 print("Not enough AP for that")
#
#     #  Concentration (3)
#     def concentration(self):
#         if self.player_select == "3":
#             if self.player.ability_power >= 3:
#                 calc_buff = 3 + self.player.level + random.choice(range(0, self.player.wisdom + 1))
#                 print(self.player.player_name + " casts Concentration, adding " + str(calc_buff) + " to attack.")
#                 self.player.ability_power -= 3
#                 self.player.turn -= 1
#                 self.player.attack += calc_buff
#                 self.player_defence_cost = 1
#                 self.player_defended_recently = False
#             else:
#                 print("Not enough AP for that")
#
#     #  Meditation (4)
#     def meditation(self):
#         if self.player_select == "4":
#             if self.player.ability_power >= 4:
#                 calc_buff = 4 + self.player.level + random.choice(range(0, self.player.wisdom + 1))
#                 print(self.player.player_name + " casts Concentration, adding " + str(calc_buff) + " to defence.")
#                 self.player.ability_power -= 4
#                 self.player.defence += calc_buff
#                 self.player_defence_cost = 1
#                 self.player_defended_recently = False
#             else:
#                 print("Not enough AP for that")
#


# New object for every combat instance, uses the values from combat and spells to effect combat.
class SpellInvoker(object):
    def __init__(self, PC, mob):
        self.player = PC
        self.mob = mob
        self.spell_book = PC.spell_book
        self.player_select = 0
        self.temp_effect_string = ''
        self.temp_effect_duration = 0
        self.temp_effect_damage = 0

    def menu(self):
        while True:
            try:
                for spell in self.player.spell_book:
                    print("\nPlease select a spell:\n")
                    print("    " + str(self.player.spell_book.index(spell) + 1) + ": " + spell["name"] +
                          " | AP Cost: " + str(spell["ap_cost"]))
                print("    " + str(len(self.player.spell_book) + 1) + ": Cancel")
                player_select = int(input()) - 1
                if player_select == (len(self.player.spell_book)):
                    break
                elif player_select == -1:  # For when the user enters 0 for some reason.
                    player_select = "The user can't type"
                if self.player.spell_book[player_select]:
                    print(self.player.spell_book[player_select]["name"])
                    self.effect(self.spell_book[player_select])
            except IndexError:  # What happens when the user picks a number that isn't an index + 1
                print("Please use the numbers on the menu to select a spell")
            except ValueError:  # What happens when the user inputs a string
                print("Please use the numbers on the menu to select a spell")
            except TypeError:  # What happens as the result of changing the input to a string.
                print("Please use the numbers on the menu to select a spell")
            else:
                break

    def effect(self, spell):
        name = spell["name"]
        heal = spell["heal"]
        damage = spell["damage"]
        text_out = spell["text_out"]
        ap_cost = spell["ap_cost"]
        temp_effect_duration = spell["temp_effect_duration"]
        temp_effect_damage = spell["temp_effect_damage"]
        temp_effect_string = spell["temp_effect_string"]

        self.player.current_health += heal
        self.mob.current_health -= damage
        self.player.ability_power -= ap_cost
        self.temp_effect_duration += temp_effect_duration
        self.temp_effect_damage += temp_effect_damage
        self.temp_effect_string += temp_effect_string
        print(text_out)


class Spells(object):
    def __init__(self, PC):
        self.player = PC

    def fireball(self):
        name = "Fireball"
        heal = 0
        damage = 5 + self.player.level + random.choice(range(0, self.player.wisdom + 1))
        text_out = self.player.player_name + " casts Fireball, dealing " + str(damage) + " damage."
        ap_cost = 5
        temp_effect_duration = 3
        temp_effect_damage = 3 + self.player.level
        temp_effect_string = "\n" + name + " deals " + str(temp_effect_damage) + " damage.\n"

        effects = dict(name=name, heal=heal, damage=damage, text_out=text_out,
                       ap_cost=ap_cost, temp_effect_duration=temp_effect_duration,
                       temp_effect_damage=temp_effect_damage, temp_effect_string=temp_effect_string)

        return effects






